def tesserver():
    from tes import app
    app.config['ENABLELAUNCH'] = True
    from flask_cors import CORS, cross_origin
    CORS(app, supports_credentials=True, origin="*")
    app.run(host='localhost',debug=False,port=8080)

def tws(stop=None):
    from twsproxy import server
    import sys
    import os
    import logging
    port = 8090
    logger=logging.getLogger()
    if port is None:
        try:
            port = int(sys.argv[1])
        except:
            port = 8090
    server = server.TWSServer(port,5,stop)
    server.run()

def stopThreads(signum,frame,event,old_handler):
    import logging
    logger = logging.getLogger()
    event.set()
    if callable(old_handler):
        old_handler(signum,frame)
    return

def main():
    import logging
    import signal
    logging.basicConfig(filename="tes.log",format="%(asctime)s %(levelname)s:%(process)s: %(message)s")
    logger=logging.getLogger()
    logger.setLevel(logging.DEBUG)
    old_handler = signal.getsignal(signal.SIGINT)
    signal.signal(signal.SIGINT, lambda x,y: stopThreads(x,y,stop,old_handler))
    import threading
    stop=threading.Event()
    twsthread = threading.Thread(target=tws,args=[stop])
    twsthread.start()
    tesserver()
    twsthread.join()

    
if __name__ == "__main__":
    main()
